
#ifndef __INIT_H
#define __INIT_H


#include <rtems.h>
#include <rtems/extension.h>


void *init(void *args);

#define CONFIGURE_POSIX_INIT_THREAD_TABLE
#define CONFIGURE_POSIX_INIT_THREAD_ENTRY_POINT init


#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER

// Without an increased driver table size, or an RTEMS patch similar to that in http://www.rtems.org/pipermail/rtems-users/2013-August/011770.html , I2C bus probe fails
#define CONFIGURE_MAXIMUM_DRIVERS 10

#define CONFIGURE_MAXIMUM_POSIX_THREADS 10
#define CONFIGURE_MAXIMUM_SEMAPHORES    10 // Required for at least RTEMS' termios driver
#define CONFIGURE_MAXIMUM_TASKS         10 // Required for at least RTEMS' termios driver


// Fatal Extension, called when things have gone horribly wrong and we're crashing
//
// See http://rtems.org/onlinedocs/doc-current/share/rtems/html/c_user/User-Extensions-Manager-FATAL-Error-Extension.html [Accessed: 2013-08-07]
void fatal_extension(Internal_errors_Source the_source,
                     bool                   is_internal,
                     Internal_errors_t      the_error);

#define CONFIGURE_INITIAL_EXTENSIONS { .fatal = fatal_extension } // Install the Fatal Extension


#define CONFIGURE_CONFDEFS_DEBUG

#define CONFIGURE_STACK_CHECKER_ENABLED


#include <rtems/confdefs.h>


#endif // __INIT_H
